<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class SmPropostasAlimentacaoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    public function getPropostasAlimentacao()
    {
        $sql = "SELECT 
                     o.NRSEQORCAMENTO, 
                     o.NRPARCNEGOCIO,
                     o.CDFILIAL,
                     o.NRORCAMENTO,
                     o.NRVERSAOORCAMENTO,
                     o.CDFILICONTATO,
                     o.NRCONTATO,
                     o.NRTIPOORCAMENTO,
                     o.NRPARCTRANSPORTADORA,
                     o.DTREFORCAMENTO,
                     o.CDPRECBASESERV,
                     o.CDREDUCONT,
                     o.IDFATURAORCA,
                     o.CDMODPGTO,
                     o.NRPARCINTERLOCUTOR,
                     o.NRGRUPOFATURA,
                     o.DSREFERENCIAORCA,
                     o.IDTRANSPORTADORA,
                     o.QTDIASVALIDADE,
                     o.DTVALIDADE,
                     o.QTDIASCONTRATO,
                     o.DTINICIOCONTRATO,
                     o.DTFIMCONTRATO,
                     o.NMPRINCIPALPARC,
                     o.DSEMAIL,
                     o.NMPARCINTERLOCUTOR,
                     o.NRTELEFONE,
                     o.DSOBSERVACAOORCA,
                     o.IDGERACONTRATO,
                     o.IDSITUACAOORCAMENTO,
                     o.VRORCAMENTO,
                     o.NRSEQORCAMENTOPAI,
                     o.CDSEQORCAMENTO,
                     o.NRORG,
                     o.IDATIVO,
                     o.DTINCLUSAO,
                     o.DTULTATU,
                     o.NRORGINCLUSAO,
                     o.CDOPERINCLUSAO,
                     o.NRORGULTATU,
                     o.CDOPERULTATU,
                     o.DSINTERORCA,
                     o.NRORCAMENTOMODELO,
                     om.NMORCAMENTOMODELO, 
                     es.NMTIPOORCAMENTO,
                     o.DTACEITEORCA,
                     o.NRSEQCONTATO,
                     o.NRSEQOPORT,
                     o.IDORCAFILHO,
                     o.NRORCAMENTORELAC,
                     o.NRDIASCARENCIA,
                     o.QTPARCELASFATU,
                     o.NRDIAVENCPARCELASFATU,
                     o.NRSEQINTERLOCUTOR,
                     o.CDOPERRESPONSAVEL,
                     o.IDPRODUTO,
                     o.DSJUSTIFCANCRENEG,
                     o.VRPERCMARKUP,
                     o.IDPROPALIMENTICIA,
                     o.VRPERCMARKUPAPLICADO,
                     o.NRSOLISERV,
                     o.DSALTERACONTRATUAIS,
                     o.IDASSELETRDIGITAL,
                     o.ISSUEID,
                     o.IDENVIADOCOPERRESPCONCASS,
                     o.JSONOMVALIDATEELEMENTS,
                     o.CDIDIOM,
                     o.NRMOEDA,
                     o.NRPARCINTERLOCUTORFAT,
                     o.NRREVENDA 
                 FROM fct_orcamento o
                 LEFT JOIN fct_orcamentomodelo om ON o.NRORCAMENTOMODELO = om.NRORCAMENTOMODELO
                 LEFT JOIN FCT_TIPOORCAMENTO es ON es.NRTIPOORCAMENTO = o.NRTIPOORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getElementosComposicaoServico($nrtipoorcamento, $nrcomposicao)
    {
        // Caso $nrtipoorcamento seja um array, converta para string separada por vírgulas
        if (is_array($nrtipoorcamento)) {
            $nrtipoorcamento = implode(',', $nrtipoorcamento);
        }
    
        $sql = "SELECT DISTINCT IDELEMENTO,
        IDELEMENTOPAI,
        IDTIPOELEMENTO,
        CDTPMEDIDAVARIAVEL,
        CDELEMENTO,
        CDSERVORCARELAC,
        NMSERVORCARELAC,
        NRTIPOORCAMENTO,
        NMTIPOORCAMENTO,
        IDALTQTDMEDIDAPROP,
        IDFATURACONTR,
        CDMODPGTO,
        NRGRUPOFATURA,
        QTPARCELASFATU,
        NRDIAVENCPARCELASFATU,
        IDUTILIZAVARPRECO,
        CDTPMEDIDASERV,
        QTMEDIDASERV,
        VRUNITARIO,
        VRPRECO,
        DTFIMVALPBSERV,
        NRORG,
        NULL AS QTMEDIDAVARIAVEL,
        IDELEMENTORAIZ,
        NMELEMENTO,
        0 AS VRCUSTOSERV,
        NRCOMPSERVICO,
        '00:00' AS HRENTRADA,
        '00:00' AS HRSAIDA,
        0 AS QTDOMINGO,
        0 AS QTSABADO,
        0 AS QTMENSAL,
        0 AS QTSEGUNDA,
        0 AS QTTERCA,
        0 AS QTQUARTA,
        0 AS QTQUINTA,
        0 AS QTSEXTA,
        0 AS QTDIAUTIL,
        0 AS QTFIMSEMANA
        FROM (SELECT DISTINCT COMPOSICAO.IDELEMENTO,
             COMPOSICAO.IDELEMENTOPAI,
             COMPOSICAO.IDTIPOELEMENTO,
             COMPOSICAO.CDTPMEDIDAVARIAVEL,
             COMPOSICAO.CDELEMENTO,
             COMPOSICAO.CDSERVORCARELAC,
             COMPOSICAO.NMSERVORCARELAC,
             COMPOSICAO.NRTIPOORCAMENTO,
             COMPOSICAO.NMTIPOORCAMENTO,
             COMPOSICAO.IDALTQTDMEDIDAPROP,
             COMPOSICAO.IDFATURACONTR,
             COMPOSICAO.CDMODPGTO,
             COMPOSICAO.NRGRUPOFATURA,
             COMPOSICAO.QTPARCELASFATU,
             COMPOSICAO.NRDIAVENCPARCELASFATU,
             COMPOSICAO.IDUTILIZAVARPRECO,
             COMPOSICAO.CDTPMEDIDASERV,
             COMPOSICAO.QTMEDIDASERV,
             COMPOSICAO.VRPRECO AS VRUNITARIO,
             COMPOSICAO.VRPRECO * COMPOSICAO.QTMEDIDASERV AS VRPRECO,
             TO_CHAR(COMPOSICAO.DTFIMVALPBSERV, 'DD/MM/YYYY') AS DTFIMVALPBSERV,
             COMPOSICAO.NRORG,
             COMPOSICAO.IDELEMENTORAIZ,
             COMPOSICAO.NRCOMPSERVICO,
             ELE.NMSERVORCA AS NMELEMENTO
            FROM (SELECT DISTINCT ITEM.NRCOMPSERVICO,
                 ITEM.IDELEMENTO,
                 ITEM.IDELEMENTOPAI,
                 ELEMENTO.IDTIPOELEMENTO,
                 ELEMENTO.CDTPMEDIDAVARIAVEL,
                 ITEM.CDSERVORCA AS CDELEMENTO,
                 ITEM.IDSERVOBRIGCOMP,
                 SERVRELAC.CDSERVORCARELAC,
                 SERVICO.NMSERVORCA AS NMSERVORCARELAC,
                 ITESCOPO.NRTIPOORCAMENTO,
                 ESCOPO.NMTIPOORCAMENTO,
                 ESCOPO.IDALTQTDMEDIDAPROP,
                 ESCOPO.IDUTILIZAVARPRECO,
                 DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.IDFATURACONTR, PARAMSRV.IDFATURACONTR) AS IDFATURACONTR,
                 DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.CDMODPGTO, PARAMSRV.CDMODPGTO) AS CDMODPGTO,
                 DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.NRGRUPOFATURA, PARAMSRV.NRGRUPOFATURA) AS NRGRUPOFATURA,
                 DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.QTPARCELASFATU, PARAMSRV.QTPARCELASFATU) AS QTPARCELASFATU,
                 DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.NRDIAVENCPARCELASFATU, PARAMSRV.NRDIAVENCPARCELASFATU) AS NRDIAVENCPARCELASFATU,
                 ITPRECO.CDTPMEDIDASERV,
                 DECODE(ITPRECO.VRPRECO, NULL, NULL, SERVRELAC.QTMEDIDASERV) AS QTMEDIDASERV,
                 ITPRECO.VRPRECO,
                 ITPRECO.DTFIMVALPBSERV,
                 ITEM.NRORG,
                 (SELECT DISTINCT IDELEMENTO
                       FROM FCT_ITCOMPSERVICO
                      WHERE NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                        AND CONNECT_BY_ISLEAF = 1
                    CONNECT BY PRIOR IDELEMENTOPAI = IDELEMENTO
                        AND PRIOR NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                      START WITH IDELEMENTO = ITEM.IDELEMENTO) AS IDELEMENTORAIZ
            FROM FCT_ITCOMPSERVICO ITEM
            LEFT JOIN FCT_RELACSERVICO SERVRELAC
                ON ITEM.CDSERVORCA = SERVRELAC.CDSERVORCA
                AND ITEM.NRORG      = SERVRELAC.NRORG
            LEFT JOIN FCT_SERVICOORCA SERVICO
                ON SERVRELAC.CDSERVORCARELAC = SERVICO.CDSERVORCA
                AND SERVRELAC.NRORG           = SERVICO.NRORG
            LEFT JOIN FCT_SERVICOORCA ELEMENTO
                ON ITEM.CDSERVORCA      = ELEMENTO.CDSERVORCA
                AND ITEM.NRORG           = ELEMENTO.NRORG 
            LEFT JOIN FCT_ITESCOPOPROPOSTA ITESCOPO
                ON SERVRELAC.CDSERVORCARELAC = ITESCOPO.CDSERVORCA
                AND SERVRELAC.NRORG           = ITESCOPO.NRORG
                AND ITESCOPO.NRTIPOORCAMENTO IN ($nrtipoorcamento)
            LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                ON ITESCOPO.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
                AND ITESCOPO.NRORG           = ESCOPO.NRORG
            LEFT JOIN FCT_PARAMFATESCOPO PARAMESC
                ON ESCOPO.NRTIPOORCAMENTO = PARAMESC.NRTIPOORCAMENTO
                AND ESCOPO.NRORG           = PARAMESC.NRORG
            LEFT JOIN FCT_PARAMFATSRVESCO PARAMSRV
                ON ITESCOPO.NRITESCOPOPROPOSTA = PARAMSRV.NRITESCOPOPROPOSTA
                AND ITESCOPO.NRORG              = PARAMSRV.NRORG
            LEFT JOIN FCT_ITPRECBASESERV ITPRECO
                ON ESCOPO.CDPRECBASESERV = ITPRECO.CDPRECBASESERV
                AND ESCOPO.NRORG          = ITPRECO.NRORG
                AND ITESCOPO.CDSERVORCA   = ITPRECO.CDSERVORCA
                WHERE ITEM.NRCOMPSERVICO IN ($nrcomposicao)
              AND ITEM.NRORG = :NRORG
              AND TRUNC(NVL(ITPRECO.DTINIPBSERV,SYSDATE)) <= TRUNC(SYSDATE)) COMPOSICAO
        LEFT JOIN FCT_SERVICOORCA ELE
            ON COMPOSICAO.IDELEMENTO = ELE.IDELEMENTO
            AND COMPOSICAO.NRORG     = ELE.NRORG)
        order by IDELEMENTO";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
    


    public function getEscopoFaturamentoProposta($params)
    {
        // Evitar SQL Injection


        $sql = " SELECT * 
                FROM    FCT_TIPOORCAMENTO";


        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTabServicosPropostas($nrtipoorcamento)
    {
        $sql = "SELECT *
                FROM FCT_SERVICOORCA";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $nrtipoorcamento);
    }
    



    public function getFormacaoPreco()
    {
        $sql = "SELECT NRFORMPRECOSERVICO, NMFORMPRECOSERVICO
                 FROM FCT_FORMPRECOSERVICO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTabFormacaoPreco($params)
    {
        $sql = "SELECT 
                    NRRELACFORMINVEST,
                    NRINVESTIMENTO,
                    NRFORMPRECOSERVICO,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO
                FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRINVESTIMENTO = :NRINVESTIMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getComposicaoInvestimento($params)
    {
        $sql = "SELECT FCT_RELACSERVINVESTIMENTO.NRRELACSERVINVEST,
            FCT_RELACSERVINVESTIMENTO.NRINVESTIMENTO,
            FCT_RELACSERVINVESTIMENTO.NRCOMPSERVICO,
            FCT_COMPSERVICO.NMCOMPSERVICO,
            FCT_COMPSERVICO.NRCOMPSERVICOPAI,
            COMP_PAI.NMCOMPSERVICO AS NMCOMPSERVICOPAI,
            FCT_RELACSERVINVESTIMENTO.NRORG,
            FCT_RELACSERVINVESTIMENTO.DTINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.NRORGINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.CDOPERINCLUSAO,
            OPINC.NMOPERADOR AS NMOPERINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.DTULTATU,
            FCT_RELACSERVINVESTIMENTO.NRORGULTATU,
            FCT_RELACSERVINVESTIMENTO.CDOPERULTATU,
            OPATU.NMOPERADOR AS NMOPERULTATU,
            FCT_RELACSERVINVESTIMENTO.IDATIVO
        FROM
            FCT_RELACSERVINVESTIMENTO
        INNER JOIN FCT_COMPSERVICO ON FCT_RELACSERVINVESTIMENTO.NRCOMPSERVICO = FCT_COMPSERVICO.NRCOMPSERVICO
        AND FCT_RELACSERVINVESTIMENTO.NRORG = FCT_COMPSERVICO.NRORG
        LEFT JOIN FCT_COMPSERVICO COMP_PAI ON FCT_COMPSERVICO.NRCOMPSERVICOPAI = COMP_PAI.NRCOMPSERVICO
        AND FCT_COMPSERVICO.NRORG = COMP_PAI.NRORG
        LEFT JOIN OPERADOR OPINC ON FCT_RELACSERVINVESTIMENTO.CDOPERINCLUSAO = OPINC.CDOPERADOR
        AND FCT_RELACSERVINVESTIMENTO.NRORG = OPINC.NRORG
        LEFT JOIN OPERADOR OPATU ON FCT_RELACSERVINVESTIMENTO.CDOPERULTATU = OPATU.CDOPERADOR
        AND FCT_RELACSERVINVESTIMENTO.NRORG = OPATU.NRORG
        WHERE FCT_RELACSERVINVESTIMENTO.NRINVESTIMENTO = :NRINVESTIMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    
    public function getInvestimentosPropostaAlimentacao($params)  
    {
        $sql = "SELECT 
                     fi.NRINVESTIMENTO,
                     fi.DSINVESTIMENTO,
                     fi.CDCATINVEST,
                     fc.NMCATINVEST,
                     fi.VRINVESTIMENTO,
                     fi.QTMESARMOTIZACAO,
                     fi.VRPERCJUROS,
                     fi.PERIODOJUROS,
                     fi.TPAMORTIZACAO,
                     fi.DTINCLUSAO,
                     fi.NRORG,
                     fi.DTULTATU,
                     fi.NRORGINCLUSAO,
                     fi.CDOPERINCLUSAO,
                     fi.NRORGULTATU,
                     fi.CDOPERULTATU,
                     fi.IDATIVO
                 FROM FCT_INVESTIMENTO fi
                 LEFT JOIN FCT_CATINVESTIMENTO fc ON fi.CDCATINVEST = fc.CDCATINVEST";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }    

    public function inserirInvestimento(array $params)
    {
        $sql = "INSERT INTO FCT_INVESTIMENTO 
                    (NRINVESTIMENTO,
                     DSINVESTIMENTO,
                     CDCATINVEST,
                     VRINVESTIMENTO,
                     QTMESARMOTIZACAO,
                     DTINCLUSAO,
                     NRORG,
                     DTULTATU,
                     NRORGINCLUSAO,
                     CDOPERINCLUSAO,
                     NRORGULTATU,
                     CDOPERULTATU,
                     IDATIVO)
             VALUES (:NRINVESTIMENTO,
                     :DSINVESTIMENTO,
                     :CDCATINVEST,
                     :VRINVESTIMENTO,
                     :QTMESARMOTIZACAO,
                     SYSDATE,
                     :NRORG,
                     NULL,
                     :NRORGINCLUSAO,
                     :CDOPERINCLUSAO,
                     NULL,
                     NULL,
                     :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarInvestimento(array $params)
    {
        $sql = "UPDATE FCT_INVESTIMENTO SET 
                DSINVESTIMENTO = :DSINVESTIMENTO,
                CDCATINVEST = :CDCATINVEST,
                VRINVESTIMENTO = :VRINVESTIMENTO,
                QTMESARMOTIZACAO = :QTMESARMOTIZACAO,
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                IDATIVO = :IDATIVO
            WHERE NRINVESTIMENTO = :NRINVESTIMENTO";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarProposta(array $params)
{
    $sql = "UPDATE FCT_ORCAMENTO SET 
            NRORCAMENTOMODELO = :NRORCAMENTOMODELO,
            NRVERSAOORCAMENTO = :NRVERSAOORCAMENTO,
            DTREFORCAMENTO = :DTREFORCAMENTO,
            IDSITUACAOORCAMENTO = :IDSITUACAOORCAMENTO,
            VRORCAMENTO = :VRORCAMENTO,
            DTACEITEORCA = :DTACEITEORCA,
            NRPARCNEGOCIO = :NRPARCNEGOCIO,
            VRPERCMARKUP = :VRPERCMARKUP,
            QTDIASVALIDADE = :QTDIASVALIDADE,
            DTVALIDADE = :DTVALIDADE,
            NRDIASCARENCIA = :NRDIASCARENCIA,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarCalcFormPrecServ(array $params)
{
    $sql = "UPDATE FCT_CALCFORMPRECSERV SET 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRCALCFORMPRECSERV = :NRCALCFORMPRECSERV";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarRelacServOrcamento(array $params)
{
    $sql = "UPDATE FCT_RELACSERVORCAMENTO SET 
            QTSEGUNDA = :QTSEGUNDA,
            QTTERCA = :QTTERCA,
            QTQUARTA = :QTQUARTA,
            QTQUINTA = :QTQUINTA,
            QTSEXTA = :QTSEXTA,
            QTSABADO = :QTSABADO,
            QTDOMINGO = :QTDOMINGO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRRELACSERVORCA = :NRRELACSERVORCA";

    $this->connection->executeStatement($sql, $params);
}
    public function inserirCalcFormPrecServ(array $params)
{
    $sql = "INSERT INTO FCT_CALCFORMPRECSERV 
                (NRCALCFORMPRECSERV,
                 NRFORMPRECOSERVICO,
                 NRORG,
                 DTINCLUSAO,
                 DTULTATU,
                 NRORGINCLUSAO,
                 CDOPERINCLUSAO,
                 NRORGULTATU,
                 CDOPERULTATU,
                 IDATIVO)
         VALUES (:NRCALCFORMPRECSERV,
                 :NRFORMPRECOSERVICO,
                 :NRORG,
                 SYSDATE,
                 SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :NRORGULTATU,
                 :CDOPERULTATU,
                 :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}
    public function inserirProposta(array $params)
{
    $sql = "INSERT INTO FCT_ORCAMENTO 
            (NRSEQORCAMENTO, 
             NRORCAMENTOMODELO, 
             NRVERSAOORCAMENTO, 
             DTREFORCAMENTO, 
             IDSITUACAOORCAMENTO, 
             VRORCAMENTO, 
             DTACEITEORCA, 
             NRPARCNEGOCIO, 
             VRPERCMARKUP,  
             QTDIASVALIDADE, 
             DTVALIDADE, 
             NRDIASCARENCIA, 
             NRORG, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             IDATIVO)
    VALUES (:NRSEQORCAMENTO, 
            :NRORCAMENTOMODELO, 
            :NRVERSAOORCAMENTO, 
            SYSDATE, 
            :IDSITUACAOORCAMENTO, 
            :VRORCAMENTO, 
            SYSDATE, 
            :NRPARCNEGOCIO, 
            :VRPERCMARKUP, 
            :QTDIASVALIDADE, 
            SYSDATE, 
            :NRDIASCARENCIA, 
            :NRORG, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO, 
            :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

public function inserirRelacServOrcamento(array $params)
{
    $sql = "INSERT INTO FCT_RELACSERVORCAMENTO 
                (NRRELACSERVORCA,
                NRSEQORCAMENTO,
                 QTSEGUNDA,
                 QTTERCA,
                 QTQUARTA,
                 QTQUINTA,
                 QTSEXTA,
                 QTSABADO,
                 QTDOMINGO,
                 NRORG,
                 DTINCLUSAO,
                 DTULTATU,
                 NRORGINCLUSAO,
                 CDOPERINCLUSAO,
                 NRORGULTATU,
                 CDOPERULTATU,
                 IDATIVO)
            VALUES (:NRRELACSERVORCA,
                 :NRSEQORCAMENTO,
                    :QTSEGUNDA,
                    :QTTERCA,
                    :QTQUARTA,
                    :QTQUINTA,
                    :QTSEXTA,
                    :QTSABADO,
                    :QTDOMINGO,
                    :NRORG,
                    SYSDATE,
                    SYSDATE,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :NRORGULTATU,
                    :CDOPERULTATU,
                    :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}



public function inserirImpostoServ(array $params)
{
    $sql = "INSERT INTO FCT_RELACIMPOSTOSERV 
            (NRIMPOSTOSERV, 
             CDIMPOSTO, 
             VRPRECIMPOSTO, 
             NRCOMPSERVICO, 
             NRORG, 
             IDATIVO, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO)
    VALUES (:NRIMPOSTOSERV, 
            :CDIMPOSTO, 
            :VRPRECIMPOSTO, 
            :NRCOMPSERVICO, 
            :NRORG, 
            :IDATIVO, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO)";

    $this->connection->executeStatement($sql, $params);
}

public function inserirTaxa(array $params)
{
    $sql = "INSERT INTO FCT_TAXAS 
            (CDTAXA, 
             DSTAXA, 
             VRPERCTAXA, 
             NRORG, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             IDATIVO)
    VALUES (:CDTAXA, 
            :DSTAXA, 
            :VRPERCTAXA, 
            :NRORG, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO, 
            :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarDespesa(array $params) 
{
    $sql = "UPDATE FCT_DESPESA SET 
                DSDESPESA = :DSDESPESA, 
                VRDESPESA = :VRDESPESA, 
                CDPERIODO = :CDPERIODO, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE CDDESPESA = :CDDESPESA";

    $this->connection->executeStatement($sql, $params);
}

public function inserirDespesa(array $params)
{
    $sql = "INSERT INTO FCT_DESPESA 
                (CDDESPESA, DSDESPESA, VRDESPESA, CDPERIODO, 
                 DTINCLUSAO, NRORG, DTULTATU, NRORGINCLUSAO, 
                 CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
            VALUES (:CDDESPESA, :DSDESPESA, :VRDESPESA, :CDPERIODO, 
                    SYSDATE, :NRORG, NULL, :NRORGINCLUSAO, 
                    :CDOPERINCLUSAO, NULL, NULL, :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

    public function inserirRelacServInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACSERVINVESTIMENTO 
                (NRRELACSERVINVEST, 
                 NRINVESTIMENTO, 
                 NRCOMPSERVICO, 
                 NRCOMPSERVICOPAI, 
                 NRORG, 
                 DTINCLUSAO, 
                 DTULTATU, 
                 NRORGINCLUSAO, 
                 CDOPERINCLUSAO, 
                 NRORGULTATU, 
                 CDOPERULTATU, 
                 IDATIVO)
        VALUES (:NRRELACSERVINVEST, 
                :NRINVESTIMENTO, 
                :NRCOMPSERVICO, 
                :NRCOMPSERVICOPAI, 
                :NRORG, 
                SYSDATE,
                NULL,
                :NRORGINCLUSAO, 
                :CDOPERINCLUSAO,  
                :NRORGULTATU, 
                :CDOPERULTATU, 
                :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacServInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACSERVINVESTIMENTO SET 
                NRINVESTIMENTO = :NRINVESTIMENTO, 
                NRCOMPSERVICO = :NRCOMPSERVICO, 
                NRCOMPSERVICOPAI = :NRCOMPSERVICOPAI, 
                NRORG = :NRORG, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE NRRELACSERVINVEST = :NRRELACSERVINVEST";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirRelacFormInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACFORMINVESTIMENTO 
            (NRRELACFORMINVEST, 
             NRINVESTIMENTO, 
             NRFORMPRECOSERVICO, 
             NRORG, 
             DTINCLUSAO, 
             DTULTATU, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             NRORGULTATU, 
             CDOPERULTATU, 
             IDATIVO)
    VALUES (:NRRELACFORMINVEST, 
            :NRINVESTIMENTO, 
            :NRFORMPRECOSERVICO, 
            :NRORG, 
            SYSDATE,
            NULL,
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO,  
            :NRORGULTATU, 
            :CDOPERULTATU, 
            :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacFormInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACFORMINVESTIMENTO SET 
            NRINVESTIMENTO = :NRINVESTIMENTO, 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO, 
            NRORG = :NRORG, 
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU, 
            CDOPERULTATU = :CDOPERULTATU, 
            IDATIVO = :IDATIVO
        WHERE NRRELACFORMINVEST = :NRRELACFORMINVEST";

        $this->connection->executeStatement($sql, $params);
    }

    public function saveTabImposto(array $params)
    {
        $sql = "INSERT INTO FCT_RELACIMPOSTOSERV (
            NRIMPOSTOSERV, CDIMPOSTO, VRPRECIMPOSTO, NRORG, 
            DTINCLUSAO, IDATIVO, NRORGINCLUSAO, CDOPERINCLUSAO
        ) VALUES (
            :NRIMPOSTOSERV, :CDIMPOSTO, :VRPRECIMPOSTO, :NRORG, 
            SYSDATE, :IDATIVO, :NRORGINCLUSAO, :CDOPERINCLUSAO
        )";
    
        $this->connection->executeStatement($sql, $params);
    }
    
    public function updateTabImposto(array $params)
    {
        $sql = "UPDATE FCT_RELACIMPOSTOSERV SET 
                CDIMPOSTO = :CDIMPOSTO,
                VRPRECIMPOSTO = :VRPRECIMPOSTO,
                NRORG = :NRORG,
                NRORGULTATU = :NRORGULTATU,
                NRORGINCLUSAO = :NRORGINCLUSAO,
                CDOPERINCLUSAO = :CDOPERINCLUSAO,
                CDOPERULTATU = :CDOPERULTATU,
                IDATIVO = :IDATIVO
            WHERE NRIMPOSTOSERV = :NRIMPOSTOSERV";
    
        $this->connection->executeStatement($sql, $params);
    }

    public function deleteInvest($parametros)
    {
        $sql2 = "DELETE FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRRELACFORMINVEST IN (" . $parametros . ")";
        $this->connection->executeStatement($sql2);
        $sql1 = "DELETE FROM FCT_RELACSERVINVESTIMENTO
                WHERE NRRELACSERVINVEST IN (" . $parametros . ")";
        $this->connection->executeStatement($sql1);
        $sql = "DELETE FROM  FCT_INVESTIMENTO
                WHERE NRINVESTIMENTO IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteComposi($parametros)
    {
        $sql = "DELETE FROM FCT_RELACSERVINVESTIMENTO
                WHERE NRRELACSERVINVEST IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteFormPreco($parametros)
    {
        $sql = "DELETE FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRRELACFORMINVEST IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    /**
     * Deleta alguns servicos do imposto
     **/
    public function deleteServicoImposto(array $params, $nrimposto)
    {
        $sql = "DELETE FROM FCT_RELACIMPOSTOSERV
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG
                    AND NRIMPOSTOSERV IN($nrimposto)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
     **/
    public function salvarEdicaoImposto(array $params)
    {
        $sql = "UPDATE FCT_RELACIMPOSTOSERV
                SET VRPRECIMPOSTO = :VRPRECIMPOSTO
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}