<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class SmPropostasDespesasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    /**
     * Deleta um imposto
     **/

    public function getDespesasproposta()
    {
        $sql = "SELECT *   
                 FROM FCT_DESPESA";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTabFormacaoPreco($params)
{
    $sql = "SELECT 
                CDRELACFORMDESP,
                CDDESPESA,
                NRFORMPRECOSERVICO,
                NRORG,
                DTINCLUSAO,
                DTULTATU,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                CDOPERULTATU,
                IDATIVO
            FROM FCT_RELACFORMACAODESPESA
            WHERE CDDESPESA = :CDDESPESA";

    return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
}

    public function getComposicaoDespesas($params)
    {
        $sql = "SELECT 
                    FCT_RELACSERVICODESPESA.CDRELACSERVICODESP,
                    FCT_RELACSERVICODESPESA.CDDESPESA,
                    FCT_RELACSERVICODESPESA.NRCOMPSERVICO,
                    FCT_COMPSERVICO.NMCOMPSERVICO,
                    FCT_COMPSERVICO.NRCOMPSERVICOPAI,
                    COMP_PAI.NMCOMPSERVICO AS NMCOMPSERVICOPAI,
                    FCT_RELACSERVICODESPESA.NRORG,
                    FCT_RELACSERVICODESPESA.DTINCLUSAO,
                    FCT_RELACSERVICODESPESA.DTULTATU,
                    FCT_RELACSERVICODESPESA.NRORGINCLUSAO,
                    FCT_RELACSERVICODESPESA.CDOPERINCLUSAO,
                    OPINC.NMOPERADOR AS NMOPERINCLUSAO,
                    FCT_RELACSERVICODESPESA.NRORGULTATU,
                    FCT_RELACSERVICODESPESA.CDOPERULTATU,
                    OPATU.NMOPERADOR AS NMOPERULTATU,
                    FCT_RELACSERVICODESPESA.IDATIVO
                FROM FCT_RELACSERVICODESPESA
                INNER JOIN FCT_COMPSERVICO 
                    ON FCT_RELACSERVICODESPESA.NRCOMPSERVICO = FCT_COMPSERVICO.NRCOMPSERVICO
                    AND FCT_RELACSERVICODESPESA.NRORG = FCT_COMPSERVICO.NRORG
                LEFT JOIN FCT_COMPSERVICO COMP_PAI 
                    ON FCT_COMPSERVICO.NRCOMPSERVICOPAI = COMP_PAI.NRCOMPSERVICO
                    AND FCT_COMPSERVICO.NRORG = COMP_PAI.NRORG
                LEFT JOIN OPERADOR OPINC 
                    ON FCT_RELACSERVICODESPESA.CDOPERINCLUSAO = OPINC.CDOPERADOR
                    AND FCT_RELACSERVICODESPESA.NRORG = OPINC.NRORG
                LEFT JOIN OPERADOR OPATU 
                    ON FCT_RELACSERVICODESPESA.CDOPERULTATU = OPATU.CDOPERADOR
                    AND FCT_RELACSERVICODESPESA.NRORG = OPATU.NRORG
                WHERE FCT_RELACSERVICODESPESA.CDDESPESA = :CDDESPESA";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }
    
    public function inserirRelacServInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACSERVICODESPESA
                (CDRELACSERVICODESP, 
                 CDDESPESA, 
                 NRCOMPSERVICO, 
                 NRCOMPSERVICOPAI, 
                 NRORG, 
                 DTINCLUSAO, 
                 DTULTATU, 
                 NRORGINCLUSAO, 
                 CDOPERINCLUSAO, 
                 NRORGULTATU, 
                 CDOPERULTATU, 
                 IDATIVO)
        VALUES (:CDRELACSERVICODESP, 
                :CDDESPESA, 
                :NRCOMPSERVICO, 
                :NRCOMPSERVICOPAI, 
                :NRORG, 
                SYSDATE,
                NULL,
                :NRORGINCLUSAO, 
                :CDOPERINCLUSAO,  
                :NRORGULTATU, 
                :CDOPERULTATU, 
                :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacServInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACSERVICODESPESA SET 
                CDDESPESA = :CDDESPESA, 
                NRCOMPSERVICO = :NRCOMPSERVICO, 
                NRCOMPSERVICOPAI = :NRCOMPSERVICOPAI, 
                NRORG = :NRORG, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE CDRELACSERVICODESP = :CDRELACSERVICODESP";

        $this->connection->executeStatement($sql, $params);
    }


    public function atualizarDespesa(array $params) 
    {
        $sql = "UPDATE FCT_DESPESA SET 
                    DSDESPESA = :DSDESPESA, 
                    VRDESPESA = :VRDESPESA, 
                    CDPERIODO = :CDPERIODO, 
                    DTULTATU = SYSDATE,
                    NRORGULTATU = :NRORGULTATU, 
                    CDOPERULTATU = :CDOPERULTATU, 
                    IDATIVO = :IDATIVO
                WHERE CDDESPESA = :CDDESPESA";
    
        $this->connection->executeStatement($sql, $params);
    }
    
    public function inserirDespesa(array $params)
    {
        $sql = "INSERT INTO FCT_DESPESA 
                    (CDDESPESA, DSDESPESA, VRDESPESA, CDPERIODO, 
                     DTINCLUSAO, NRORG, DTULTATU, NRORGINCLUSAO, 
                     CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
                VALUES (:CDDESPESA, :DSDESPESA, :VRDESPESA, :CDPERIODO, 
                        SYSDATE, :NRORG, NULL, :NRORGINCLUSAO, 
                        :CDOPERINCLUSAO, NULL, NULL, :IDATIVO)";
    
        $this->connection->executeStatement($sql, $params);
    }
    
    public function inserirRelacFormInvest(array $params)
{
    $sql = "INSERT INTO FCT_RELACFORMACAODESPESA
            (CDRELACFORMDESP, 
             CDDESPESA, 
             NRFORMPRECOSERVICO, 
             NRORG, 
             DTINCLUSAO, 
             DTULTATU, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             NRORGULTATU, 
             CDOPERULTATU, 
             IDATIVO)
    VALUES (:CDRELACFORMDESP, 
            :CDDESPESA, 
            :NRFORMPRECOSERVICO, 
            :NRORG, 
            SYSDATE, 
            NULL,
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO,  
            :NRORGULTATU, 
            :CDOPERULTATU, 
            :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarRelacFormInvest(array $params)
{
    $sql = "UPDATE FCT_RELACFORMACAODESPESA SET
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO, 
            NRORG = :NRORG, 
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU, 
            CDOPERULTATU = :CDOPERULTATU, 
            IDATIVO = :IDATIVO
        WHERE CDRELACFORMDESP = :CDRELACFORMDESP";

    $this->connection->executeStatement($sql, $params);
}
  
    public function deleteDespesas($parametros)
    {
        $sql = "DELETE FROM  FCT_DESPESA
                WHERE CDDESPESA IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteRelacFormDesp($parametros)
    {
        $sql = "DELETE FROM FCT_RELACFORMACAODESPESA
                WHERE CDRELACFORMDESP IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteRelacCompDespesas($parametros)
    {
        $sql = "DELETE FROM FCT_RELACSERVICODESPESA
                WHERE CDRELACSERVICODESP IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    /**
     * Deleta alguns servicos do imposto
     **/
    public function deleteServicoImposto(array $params, $nrimposto)
    {
        $sql = "DELETE FROM FCT_RELACIMPOSTOSERV
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG
                    AND NRIMPOSTOSERV IN($nrimposto)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
     **/
    public function salvarEdicaoImposto(array $params)
    {
        $sql = "UPDATE FCT_RELACIMPOSTOSERV
                SET VRPRECIMPOSTO = :VRPRECIMPOSTO
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}