<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class SmPropostasTaxasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTaxas()
    {
        $sql = "SELECT 
                CDTAXA, 
                DSTAXA, 
                VRPERCTAXA, 
                NRORG, 
                DTINCLUSAO, 
                DTULTATU, 
                NRORGINCLUSAO, 
                CDOPERINCLUSAO, 
                NRORGULTATU, 
                CDOPERULTATU, 
                IDATIVO 
            FROM FCT_TAXAS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function saveTaxa(array $params)
    {
        $sql = "INSERT INTO FCT_TAXAS (
                CDTAXA, DSTAXA, VRPERCTAXA, NRORG, DTINCLUSAO, IDATIVO, NRORGINCLUSAO, CDOPERINCLUSAO
            ) VALUES (
                :CDTAXA, :DSTAXA, :VRPERCTAXA, :NRORG, SYSDATE, :IDATIVO, :NRORGINCLUSAO, :CDOPERINCLUSAO
            )";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateTaxa(array $params)
    {
        $sql = "UPDATE FCT_TAXAS SET 
                DSTAXA = :DSTAXA, 
                VRPERCTAXA = :VRPERCTAXA, 
                NRORG = :NRORG, 
                DTULTATU = SYSDATE, 
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE CDTAXA = :CDTAXA";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteTaxas($parametros)
    {
        $sql = "DELETE FROM  FCT_TAXAS
                WHERE  CDTAXA IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }
}